<ui:composition xmlns:gri="http://java.sun.com/jsf/composite/gri" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:h="http://java.sun.com/jsf/html"
                xmlns:rich="http://richfaces.org/rich" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <h:form id="globalForm">
            <s:decorate template="/hl7Initiators/orderSenderTemplate.xhtml">
                <ui:param name="managedBean" value="#{awosSender}"/>
                <ui:param name="availableSuts"
                          value="#{hl7v2ResponderSUTConfiguration.getAllConfigurationsForUsage('LAB_ANALYZER')}"/>
                <ui:param name="displaySequenceDiagram" value="true"/><!-- ordersDataTable -->
                <ui:define name="lawoptions">
                    <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml" id="optdec">
                        <ui:define name="label"></ui:define>
                        <ui:param name="id" value="optionsIn"/>
                        <rich:pickList id="optionsIn"
                                       value="#{awosSender.selectedOptions}" listWidth="500px">
                            <s:selectItems value="#{awosSender.getAvailableOptionsForLAW()}"
                                           var="opt"
                                           label="#{opt.displayName}"/>
                            <a4j:ajax event="change" render="optdec"/>
                        </rich:pickList>
                        <h:outputText styleClass="help-block"
                                      value="#{messages['gazelle.ordermanager.SelectTheOptionsSupportedByYourSystem']}"/>
                    </s:decorate>
                </ui:define>
                <ui:define name="ordersDataTable">
                    <rich:dataTable value="#{awosSender.orderFilter.getOrders()}" var="orderVar"
                                    rows="#{dataScrollerMemory.numberOfResultsPerPage}" id="orders1Table"
                                    render="ds">
                        <ui:include src="/common/orderColumns.xhtml">
                            <ui:param name="managedBean" value="#{awosSender}"/>
                            <ui:param name="currentOrder" value="#{orderVar}"/>
                            <ui:param name="displayEncounterInfo" value="false"/>
                            <ui:param name="enableStatusEdit" value="false"/>
                        </ui:include>
                        <g:column>
                            <ui:define name="header">#{messages['users.Action']}</ui:define>
                            <a4j:commandLink value="#{messages['gazelle.ordermanager.Select']}"
                                             actionListener="#{awosSender.setSelectedOrder(orderVar)}"
                                             oncomplete="jq162('#cancelDiscontinueOrderPanel').modal('show')"
                                             rendered="#{awosSender.orderControlCode.equals(awosSender.cancel) or awosSender.orderControlCode.equals(awosSender.discontinue)}"
                                             render="cancelContent, confirmCancelBtn"/>
                            <a4j:commandLink value="#{messages['gazelle.ordermanager.Select']}"
                                             actionListener="#{awosSender.setSelectedOrder(orderVar)}"

                                             oncomplete="jq162('#updateOrderStatusPanel').modal('show')"
                                             rendered="#{awosSender.orderControlCode.equals(awosSender.update)}"
                                             render="updateContent, confirmUpdateBtn"/>
                        </g:column>
                        <f:facet name="footer">
                            <ui:include src="/util/datatableFooter.xhtml">
                                <ui:param name="dataScrollerId" value="ds"/>
                                <ui:param name="dataTableId" value="orders1Table"/>
                            </ui:include>
                        </f:facet>
                    </rich:dataTable>
                </ui:define><!-- orderSelectionForWorkOrder to be completed there--><!-- add a link to the lab order browser (battery-centric or specimen-centric depending of the selected message structure) --><!-- newObjectPart -->
                <ui:define name="newObjectPart">
                    <!-- SPECIMEN CENTRIC -->
                    <s:div rendered="#{awosSender.selectedSpecimen != null}" id="specimenCentricDiv">
                        <s:div id="editSpecimenDiv" rendered="#{awosSender.editSpecimen}">
                            <gri:panel pid="editSpecimenPanel">
                                <f:facet name="header">#{messages['gazelle.ordermanager.CreateSpecimen']}</f:facet>
                                <f:subview id="subview_2">
                                    <ui:include src="/lab/fillingSpecimen4LAW.xhtml">
                                        <ui:param name="specimen" value="#{awosSender.selectedSpecimen}"/>
                                        <ui:param name="managedBean" value="#{awosSender}"/>
                                    </ui:include>
                                </f:subview>
                                <h2>#{messages['gazelle.ordermanager.RelatedContainer']}</h2>
                                <f:subview id="subview_3">
                                    <ui:include src="/lab/fillingContainer4LAW.xhtml">
                                        <ui:param name="currentContainer" value="#{awosSender.container}"/>
                                    </ui:include>
                                </f:subview>
                                <f:facet name="footer">
                                    <a4j:commandButton
                                            value="#{messages['gazelle.ordermanager.CreateAnOrderForSpecimen']}"
                                            actionListener="#{awosSender.createOrderForSpecimen()}"
                                            styleClass="gzl-btn-green"
                                            render="specimenCentricDiv"/>
                                </f:facet>
                            </gri:panel>
                        </s:div>
                        <s:div id="specimenDetails" rendered="#{not awosSender.editSpecimen}">
                            <gri:panel>
                                <f:facet name="header">#{messages['gazelle.ordermanager.SpecimenDetails']}</f:facet>
                                <f:subview id="subview_4">
                                    <ui:include src="/lab/specimenDetails.xhtml">
                                        <ui:param name="specimen" value="#{awosSender.selectedSpecimen}"/>
                                    </ui:include>
                                </f:subview>
                                <f:facet name="footer">
                                    <a4j:commandButton
                                            value="#{messages['gazelle.ordermanager.AddAnOrderForThisSpecimen']}"
                                            actionListener="#{awosSender.createOrderForSpecimen()}"
                                            styleClass="gzl-btn-green"
                                            render="specimenDetails"/>
                                    <a4j:commandButton value="#{messages['gazelle.ordermanager.SendMessage']}"
                                                       actionListener="#{awosSender.sendMessage()}"
                                                       rendered="#{not empty awosSender.selectedSpecimen.orders}"
                                                       styleClass="gzl-btn-blue"
                                                       immediate="true" render="globalDiv"/>
                                </f:facet>
                            </gri:panel>
                            <gri:panel>
                                <f:facet name="header">#{messages['gazelle.ordermanager.RelatedContainer']}</f:facet>
                                <f:subview id="subview_5">
                                    <ui:include src="/lab/containerDetails.xhtml">
                                        <ui:param name="container" value="#{awosSender.container}"/>
                                        <ui:param name="displayOrders" value="false"/>
                                    </ui:include>
                                </f:subview>
                            </gri:panel>
                            <!-- defined orders for the current specimen -->
                            <gri:panel>
                                <f:facet name="header">#{messages['gazelle.ordermanager.RelatedOrders']}</f:facet>
                                <h:outputText
                                        value="#{messages['gazelle.ordermanager.BelowIsTheListOfOrdersForTheCurrentSpecimen']}"
                                        rendered="#{not empty awosSender.selectedSpecimen.orders}"
                                        styleClass="help-block"/>
                                <h:outputText
                                        value="#{messages['gazelle.ordermanager.NoOrderSpecifiedForTheCurrentSpecimenYet']}"
                                        rendered="#{empty awosSender.selectedSpecimen.orders}"
                                        styleClass="help-block"/>
                                <rich:dataTable value="#{awosSender.selectedSpecimen.orders}" var="currentOrder"
                                                rendered="#{not empty awosSender.selectedSpecimen.orders}" id="orclist">
                                    <ui:include src="/common/orderColumns.xhtml">
                                        <ui:param name="managedBean" value="#{awosSender}"/>
                                        <ui:param name="currentOrder" value="#{currentOrder}"/>
                                        <ui:param name="displayEncounterInfo" value="false"/>
                                    </ui:include>
                                    <g:column>
                                        <ui:define name="header">#{messages['users.Action']}</ui:define>
                                        <a4j:commandLink
                                                title="#{messages['gazelle.ordermanager.RemoveThisOrderFromTheSpecimen']}"
                                                actionListener="#{awosSender.removeOrderFromSpecimen(currentOrder)}"
                                                render="specimenDetails">
                                            <s:span styleClass="gzl-icon-trash-o"/>
                                        </a4j:commandLink>
                                    </g:column>
                                    <f:facet name="footer">
                                        <ui:include src="/util/datatableFooter.xhtml">
                                            <ui:param name="dataScrollerId" value="ds"/>
                                            <ui:param name="dataTableId" value="orclist"/>
                                        </ui:include>
                                    </f:facet>
                                </rich:dataTable>
                            </gri:panel><!-- order creation -->
                            <br/>
                            <s:div rendered="#{awosSender.editOrder}">
                                <gri:panel pid="orderCreation">
                                    <f:facet name="header">
                                        <h:outputText
                                                value="#{messages['gazelle.ordermanager.CreateOrderForCurrentSpecimen']}"/>
                                        <span style="width:5px"/>
                                        <a4j:commandLink
                                                title="#{messages['gazelle.ordermanager.FillWithRandomValues']}"
                                                actionListener="#{awosSender.fillOrderRandomly()}"
                                                immediate="true" render="orderCreation">
                                            <span class="gzl-icon-random"/>
                                        </a4j:commandLink>
                                    </f:facet>
                                    <f:subview id="subview_6">
                                        <ui:include src="/lab/fillingLabOrder.xhtml">
                                            <ui:param name="order" value="#{awosSender.selectedOrder}"/>
                                            <ui:param name="displayExtraParamForOF" value="false"/>
                                            <ui:param name="isWorkOrder" value="false"/>
                                            <ui:param name="valueResultStatus" value="false"/>
                                        </ui:include>
                                    </f:subview><!-- command button -->
                                    <f:facet name="footer">
                                        <a4j:commandButton
                                                value="#{messages['gazelle.ordermanager.FillWithRandomValues']}"
                                                actionListener="#{awosSender.fillOrderRandomly()}"
                                                immediate="true" styleClass="gzl-btn-blue"
                                                render="orderCreation"/>
                                        <a4j:commandButton
                                                value="#{messages['gazelle.ordermanager.AddToCurrentSpecimen']}"
                                                actionListener="#{awosSender.addOrderToSpecimen()}"
                                                styleClass="gzl-btn-blue"
                                                render="specimenCentricDiv"/>
                                        <a4j:commandButton
                                                value="#{messages['gazelle.ordermanager.AddToCurrentSpecimenAndSendMessage']}"
                                                actionListener="#{awosSender.addOrderToSpecimenAndSendMessage()}"
                                                styleClass="gzl-btn-blue"
                                                render="globalDiv"/>
                                    </f:facet>
                                </gri:panel>
                            </s:div>
                        </s:div>
                    </s:div>
                </ui:define>
            </s:decorate>
        </h:form>
    </ui:define>
</ui:composition>
